import deleteDbEntry from "../../backend/db/deleteDbEntry";
import varDatabaseDbHandler from "../../backend/varDatabaseDbHandler";
/**
 * # Update API User Function
 */
export default async function apiDeleteUser({ dbFullName, deletedUserId, }) {
    const existingUserQuery = `SELECT * FROM ${dbFullName}.users WHERE id = ?`;
    const existingUserValues = [deletedUserId];
    const existingUser = await varDatabaseDbHandler({
        queryString: existingUserQuery,
        queryValuesArray: existingUserValues,
        database: dbFullName,
    });
    if (!(existingUser === null || existingUser === void 0 ? void 0 : existingUser[0])) {
        return {
            success: false,
            msg: "User not found",
        };
    }
    const deleteUser = await deleteDbEntry({
        dbContext: "Dsql User",
        dbFullName,
        tableName: "users",
        identifierColumnName: "id",
        identifierValue: deletedUserId,
    });
    return {
        success: true,
        result: deleteUser,
    };
}
