import grabSchemaFieldsFromData from "./grabSchemaFieldsFromData";
import serverError from "./serverError";
/**
 * # Add User Table to Database
 */
export default function grabNewUsersTableSchema(params) {
    try {
        const userPreset = require("../../data/presets/users.json");
        const defaultFields = require("../../data/defaultFields.json");
        const supplementalFields = (params === null || params === void 0 ? void 0 : params.payload)
            ? grabSchemaFieldsFromData({
                data: params === null || params === void 0 ? void 0 : params.payload,
                excludeData: defaultFields,
                excludeFields: userPreset.fields,
            })
            : [];
        console.log("supplementalFields", supplementalFields);
        const allFields = [...userPreset.fields, ...supplementalFields];
        console.log("allFields", allFields);
        const finalFields = [
            ...defaultFields.slice(0, 2),
            ...allFields,
            ...defaultFields.slice(2),
        ];
        userPreset.fields = [...finalFields];
        return userPreset;
    }
    catch ( /** @type {any} */error) {
        console.log(`grabNewUsersTableSchema.ts ERROR: ${error.message}`);
        serverError({
            component: "grabNewUsersTableSchema",
            message: error.message,
        });
        return null;
    }
}
