import mysql from "serverless-mysql";
import grabMariadbMainUserForUser from "./grab-mariadb-main-user-for-user";
import connDbHandler from "../../utils/db/conn-db-handler";
export default async function userDbHandler({ query, user, database, debug, tableSchema, values, }) {
    const { fullName, host, username, password } = await grabMariadbMainUserForUser({ user });
    const connection = mysql({
        config: {
            host,
            user: username,
            password: password,
            database: database,
            charset: "utf8mb4",
        },
    });
    const results = await connDbHandler(connection, query);
    return results;
}
