import dsqlCrud from "../../../../utils/data-fetching/crud";
import query from "./query";
import _n from "../../../../utils/numberfy";
export default async function dbGrabUserResource(params) {
    let queryObject = query(params);
    let result = await dsqlCrud({
        action: "get",
        table: params.tableName,
        query: queryObject,
        count: params.count,
        countOnly: params.countOnly,
    });
    const payload = result === null || result === void 0 ? void 0 : result.payload;
    return {
        batch: payload || null,
        single: (payload === null || payload === void 0 ? void 0 : payload[0]) || null,
        debug: {
            queryObject: result === null || result === void 0 ? void 0 : result.queryObject,
            error: result === null || result === void 0 ? void 0 : result.error,
            msg: result === null || result === void 0 ? void 0 : result.msg,
        },
        count: _n(result === null || result === void 0 ? void 0 : result.count),
    };
}
