import _ from "lodash";
import ResourceLimits from "../../../../dict/resource-limits";
import _n from "../../../../utils/numberfy";
export default function (params) {
    let queryObject = {
        limit: (params === null || params === void 0 ? void 0 : params.noLimit) ? undefined : ResourceLimits["general"],
        order: {
            field: "id",
            strategy: "DESC",
        },
    };
    if (params === null || params === void 0 ? void 0 : params.targetID) {
        const targetIDQuery = {
            query: {
                id: {
                    value: _n(params.targetID).toString(),
                },
            },
        };
        queryObject = _.merge(queryObject, targetIDQuery);
    }
    let queryFixedObject = (params === null || params === void 0 ? void 0 : params.isSuperUser)
        ? {}
        : {
            query: {
                user_id: {
                    value: String((params === null || params === void 0 ? void 0 : params.userId) || 0),
                },
            },
        };
    return _.merge(queryObject, params === null || params === void 0 ? void 0 : params.query, queryFixedObject);
}
