import varDatabaseDbHandler from "../utils/varDatabaseDbHandler";
import sqlGenerator from "../../functions/dsql/sql/sql-generator";
import numberfy from "../../utils/numberfy";
import addDbEntry from "../../functions/backend/db/addDbEntry";
/**
 * # Create database from Schema Function
 * @requires DSQL_DB_CONN - Gobal Variable for Datasquirel Database
 */
export default async function checkTableRecordCreateDbSchema({ userId, tableSchema, dbSchema, dbRecord, dbFullName, }) {
    var _a, _b;
    if (!tableSchema)
        return undefined;
    try {
        const queryObj = sqlGenerator({
            tableName: "user_database_tables",
            genObject: {
                query: {
                    db_id: {
                        value: String(dbRecord === null || dbRecord === void 0 ? void 0 : dbRecord.id),
                    },
                    table_slug: {
                        value: tableSchema.tableName,
                    },
                    user_id: {
                        value: String(userId),
                    },
                },
            },
            dbFullName: "datasquirel",
        });
        let recordedTableEntryArray = userId
            ? await varDatabaseDbHandler({
                queryString: (queryObj === null || queryObj === void 0 ? void 0 : queryObj.string) || "",
                queryValuesArray: queryObj === null || queryObj === void 0 ? void 0 : queryObj.values,
            })
            : undefined;
        let recordedTableEntry = recordedTableEntryArray === null || recordedTableEntryArray === void 0 ? void 0 : recordedTableEntryArray[0];
        if (!(recordedTableEntry === null || recordedTableEntry === void 0 ? void 0 : recordedTableEntry.id) && userId) {
            const newTableInsertObject = {
                user_id: numberfy(userId),
                db_id: dbRecord === null || dbRecord === void 0 ? void 0 : dbRecord.id,
                db_slug: dbRecord === null || dbRecord === void 0 ? void 0 : dbRecord.db_slug,
                table_slug: tableSchema.tableName,
            };
            if ((tableSchema === null || tableSchema === void 0 ? void 0 : tableSchema.childTable) && tableSchema.childTableId) {
                const parentDb = dbSchema.find((db) => db.id == tableSchema.childTableDbId);
                const parentDbTable = parentDb === null || parentDb === void 0 ? void 0 : parentDb.tables.find((tbl) => tbl.id == tableSchema.childTableId);
                if (parentDb && parentDbTable) {
                    newTableInsertObject["child_table"] = 1;
                    newTableInsertObject["child_table_parent_database_schema_id"] = numberfy(parentDb.id);
                    newTableInsertObject["child_table_parent_table_schema_id"] =
                        numberfy(parentDbTable.id);
                }
            }
            const newTableRecordEntry = await addDbEntry({
                data: newTableInsertObject,
                tableName: "user_database_tables",
                dbContext: "Master",
                forceLocal: true,
            });
            if ((_a = newTableRecordEntry.payload) === null || _a === void 0 ? void 0 : _a.insertId) {
                recordedTableEntryArray = await varDatabaseDbHandler({
                    queryString: (queryObj === null || queryObj === void 0 ? void 0 : queryObj.string) || "",
                    queryValuesArray: queryObj === null || queryObj === void 0 ? void 0 : queryObj.values,
                });
                recordedTableEntry = recordedTableEntryArray === null || recordedTableEntryArray === void 0 ? void 0 : recordedTableEntryArray[0];
            }
        }
        return recordedTableEntry;
    }
    catch (error) {
        (_b = global.ERROR_CALLBACK) === null || _b === void 0 ? void 0 : _b.call(global, `Error Checking Table Record on Creating Schema`, error);
        return undefined;
    }
}
