export const UsersOmitedFields = [
    "password",
    "social_id",
    "verification_status",
    "date_created",
    "date_created_code",
    "date_created_timestamp",
    "date_updated",
    "date_updated_code",
    "date_updated_timestamp",
];
export const TextFieldTypesArray = [
    { title: "Plain Text", value: "plain" },
    { title: "Rich Text", value: "richText" },
    { title: "JSON", value: "json" },
    { title: "YAML", value: "yaml" },
    { title: "HTML", value: "html" },
    { title: "CSS", value: "css" },
    { title: "Javascript", value: "javascript" },
    { title: "Shell", value: "shell" },
    { title: "Code", value: "code" },
];
export const ServerQueryOperators = ["AND", "OR"];
export const ServerQueryEqualities = [
    "EQUAL",
    "LIKE",
    "LIKE_RAW",
    "NOT LIKE",
    "NOT LIKE_RAW",
    "NOT EQUAL",
    "REGEXP",
    "FULLTEXT",
    "IN",
    "NOT IN",
    "BETWEEN",
    "NOT BETWEEN",
    "IS NULL",
    "IS NOT NULL",
    "EXISTS",
    "NOT EXISTS",
    "GREATER THAN",
    "GREATER THAN OR EQUAL",
    "LESS THAN",
    "LESS THAN OR EQUAL",
];
export const DataCrudRequestMethods = [
    "GET",
    "POST",
    "PUT",
    "PATCH",
    "DELETE",
    "OPTIONS",
];
export const DataCrudRequestMethodsLowerCase = [
    "get",
    "post",
    "put",
    "patch",
    "delete",
    "options",
];
export const DsqlCrudActions = ["insert", "update", "delete", "get"];
export const QueryFields = [
    "duplicate",
    "user_id",
    "delegated_user_id",
    "db_id",
    "table_id",
    "db_slug",
];
export const UserTypes = ["su", "admin"];
export const SignUpParadigms = [
    {
        name: "email",
    },
    {
        name: "google",
    },
];
export const QueueJobTypes = ["dummy", "import-database"];
export const WebSocketEvents = [
    /**
     * # Client Events
     * @description Events sent from Client to Server
     */
    "client:check-queue",
    "client:dev:queue",
    "client:delete-queue",
    "client:pty-shell",
    /**
     * # Server Events
     * @description Events sent from Server to Client
     */
    "server:error",
    "server:message",
    "server:ready",
    "server:success",
    "server:update",
    "server:queue",
    "server:dev:queue",
    "server:queue-deleted",
    "server:pty-shell",
];
export const DatasquirelWindowEvents = [
    "queue-started",
    "queue-complete",
    "queue-running",
];
export const DockerComposeServices = [
    "setup",
    "cron",
    "reverse-proxy",
    "webapp",
    "websocket",
    "static",
    "db",
    "maxscale",
    "post-db-setup",
    "web-app-post-db-setup",
    "post-replica-db-setup",
    "db-replica-1",
    "db-replica-2",
    "db-cron",
    "web-app-post-db-setup",
];
export const MediaTypes = ["image", "file", "video"];
export const ImageMimeTypes = [
    "webp",
    "gif",
    "svg",
    "png",
    "jpeg",
    "jpg",
];
export const FileMimeTypes = [
    "pdf",
    "csv",
    "json",
    "sql",
    "xlsx",
    "txt",
    "zip",
    "xz",
    "yaml",
    "yml",
];
export const VideoMimeTypes = ["mp4", "wav"];
export const CurrentlyEditedFieldActions = [
    "edit-field",
    "edit-index",
    "delete-field",
    "delete-index",
    "new-field",
    "new-index",
    "move-up",
    "move-down",
    "complete",
];
export const DefaultSQLValuesLiteral = [
    {
        title: "CURRENT_TIMESTAMP",
        value: "CURRENT_TIMESTAMP",
        description: "",
        dataType: "TIMESTAMP",
    },
    {
        title: "UUID",
        value: "UUID()",
        description: "",
        dataType: "UUID",
    },
];
export const IndexTypes = ["regular", "full_text"];
export const UserSelectFields = [
    {
        field: "first_name",
        alias: "user_first_name",
    },
    {
        field: "last_name",
        alias: "user_last_name",
    },
    {
        field: "email",
        alias: "user_email",
    },
    {
        field: "image_thumbnail",
        alias: "user_image_thumbnail",
    },
];
export const DelegatedUserSelectFields = [
    {
        field: "first_name",
        alias: "delegated_user_first_name",
    },
    {
        field: "last_name",
        alias: "delegated_user_last_name",
    },
    {
        field: "email",
        alias: "delegated_user_email",
    },
    {
        field: "image_thumbnail",
        alias: "delegated_user_image_thumbnail",
    },
];
export const InvitedUserSelectFields = [
    {
        field: "first_name",
        alias: "invited_user_first_name",
    },
    {
        field: "last_name",
        alias: "invited_user_last_name",
    },
    {
        field: "email",
        alias: "invited_user_email",
    },
    {
        field: "image_thumbnail",
        alias: "invited_user_image_thumbnail",
    },
];
export const SQLPermissions = [
    "ALL PRIVILEGES",
    "ALTER",
    "ALTER ROUTINE",
    "CREATE",
    "CREATE ROUTINE",
    "CREATE TEMPORARY TABLES",
    "CREATE VIEW",
    "DELETE",
    "DROP",
    "EVENT",
    "EXECUTE",
    "FILE",
    "INDEX",
    "INSERT",
    "LOCK TABLES",
    "PROCESS",
    "REFERENCES",
    "RELOAD",
    "REPLICATION CLIENT",
    "REPLICATION SLAVE",
    "SELECT",
    "SHOW VIEW",
    "SUPER",
    "TRIGGER",
    "UPDATE",
    "USAGE",
];
export const UserSQLPermissions = [
    "SELECT",
    "ALTER",
    "ALTER ROUTINE",
    "CREATE",
    "CREATE ROUTINE",
    "CREATE TEMPORARY TABLES",
    "CREATE VIEW",
    "DELETE",
    "DROP",
    "EVENT",
    "EXECUTE",
    "FILE",
    "INDEX",
    "INSERT",
    "LOCK TABLES",
    "PROCESS",
    "REFERENCES",
    "RELOAD",
    "SHOW VIEW",
    "SUPER",
    "TRIGGER",
    "UPDATE",
    "USAGE",
];
export const APIParadigms = ["crud", "media", "sql"];
export const AppVersions = [
    {
        title: "Community",
        value: "community",
    },
    {
        title: "Pro",
        value: "pro",
    },
    {
        title: "Enterprise",
        value: "enterprise",
    },
    {
        title: "Full",
        value: "full",
    },
];
export const EnvKeys = [
    "DSQL_HOST",
    "NEXT_PUBLIC_DSQL_HOST",
    "DSQL_STATIC_HOST",
    "DSQL_SOCKET_DOMAIN",
    "DSQL_HOST_ENV",
    "DSQL_PORT",
    "DSQL_PRODUCTION_PORT",
    "DSQL_STATIC_SERVER_PORT",
    "DSQL_SITE_URL",
    "DSQL_REMOTE_SQL_HOST",
    "NEXT_PUBLIC_DSQL_REMOTE_SQL_HOST",
    "DSQL_DB_TARGET_IP_ADDRESS",
    "NEXT_PUBLIC_VERSION",
    "DSQL_USER_DB_PREFIX",
    "DSQL_USER_DELEGATED_DB_COOKIE_PREFIX",
    "DSQL_NETWORK_IP_PREFIX",
    "DSQL_NETWORK_GATEWAY",
    "DSQL_NETWORK_SUBNET",
    "DSQL_MARIADB_MASTER_HOST",
    "DSQL_DB_HOST",
    "DSQL_WEB_APP_HOST",
    "DSQL_DB_USERNAME",
    "DSQL_DB_PASSWORD",
    "DSQL_MARIADB_ROOT_PASSWORD",
    "DSQL_REPLICATION_USER_PASSWORD",
    "DSQL_DB_NAME",
    "DSQL_MARIADB_REPLICATION_PASSWORD",
    "DSQL_MAXSCALE_PASSWORD",
    "DSQL_DB_READ_ONLY_USERNAME",
    "DSQL_DB_READ_ONLY_PASSWORD",
    "DSQL_DB_FULL_ACCESS_USERNAME",
    "DSQL_DB_FULL_ACCESS_PASSWORD",
    "DSQL_DB_EXPOSED_PORT",
    "DSQL_ENCRYPTION_PASSWORD",
    "DSQL_ENCRYPTION_SALT",
    "DSQL_SU_USER_ID",
    "DSQL_SU_USER_UUID",
    "DSQL_SU_EMAIL",
    "DSQL_GOOGLE_CLIENT_ID",
    "NEXT_PUBLIC_DSQL_GOOGLE_CLIENT_ID",
    "DSQL_FACEBOOK_APP_ID",
    "DSQL_FACEBOOK_SECRET",
    "DSQL_MAIL_HOST",
    "DSQL_MAIL_EMAIL",
    "DSQL_MAIL_PASSWORD",
    "DSQL_TINY_MCE_API_KEY",
    "DSQL_GITHUB_ID",
    "DSQL_GITHUB_SECRET",
    "DSQL_GITHUB_WEBHOOK_SECRET",
    "DSQL_GITHUB_WEBHOOK_URL",
    "DSQL_DEPLOY_SERVER_PORT",
    "DSQL_DOCKERFILE",
    "DSQL_VOLUME_APP",
    "DSQL_VOLUME_STATIC",
    "DSQL_VOLUME_STATIC_CONFIGURATION_FILE",
    "DSQL_VOLUME_DB",
    "DSQL_VOLUME_DB_CONFIG",
    "DSQL_VOLUME_DB_SETUP",
    "DSQL_VOLUME_DB_SSL",
    "DSQL_USER_LOGIN_KEYS_PATH",
    "DSQL_API_KEYS_PATH",
    "DSQL_APP_DIR",
    "DSQL_DATA_DIR",
    "DSQL_CONTACT_EMAIL",
    "DSQL_SSL_DIR",
    "DSQL_DEPLOYMENT_NAME",
    "DSQL_COOKIES_PREFIX",
    "DSQL_COOKIES_KEY_NAME",
    "DSQL_WEB_APP_FAIL_COUNTS",
    "NODE_ARCH",
    "DSQL_WEBSOCKET_PORT",
    "DSQL_WEBSOCKET_URL",
    "NEXT_PUBLIC_DSQL_WEBSOCKET_URL",
    "S3_ACCESS_KEY_ID",
    "S3_SECRET_ACCESS",
    "DSQL_ADDITIONAL_MARIADB_SERVERS",
    "DSQL_ARCJET_KEY",
];
