import slugify from "./slugify";
/**
 * # Grab full database name
 * @description Grab full database name from slug or full name
 * @param param0
 * @returns
 */
export default function grabDbFullName({ dbName, userId, user, }) {
    const finalUserId = (user === null || user === void 0 ? void 0 : user.id) || userId;
    if (!finalUserId) {
        return dbName;
    }
    if (!dbName) {
        return;
    }
    const dbNamePrefix = process.env.DSQL_USER_DB_PREFIX;
    const parsedDbName = slugify(dbName, "_");
    const dbSlug = parsedDbName.replace(new RegExp(`${dbNamePrefix}_?\\d+_`), "");
    return slugify(`${dbNamePrefix}_${finalUserId}_${dbSlug}`, "_");
}
