import grabSQLUserNameForUser from "./grab-sql-user-name-for-user";
export default function grabSQLUserName({ user, name: passedName, }) {
    if (!user) {
        console.log("No User Found");
        return {};
    }
    const sqlUsername = grabSQLUserNameForUser(user.id);
    const parsedPassedName = passedName
        ? passedName.replace(sqlUsername, "").replace(/^_+|_+$/, "")
        : undefined;
    const name = parsedPassedName
        ? `${sqlUsername}_${parsedPassedName}`
        : undefined;
    if (user.isSuperUser) {
        return {
            sqlUsername: undefined,
            name: passedName,
            nameWithoutPrefix: passedName,
        };
    }
    return { sqlUsername, name, nameWithoutPrefix: parsedPassedName };
}
